#version 430 core

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

uniform mat4 viewProjMatrix;
//uniform mat4 modelMatrix;
uniform vec3 cameraPos;
uniform float particleSize;

in float type0[];
out vec2 texCoords;

#define PARTICLE_TYPE_LAUNCHER 0.0f
#define PARTICLE_TYPE_SHELL 1.0f
#define PARTICLE_TYPE_SECONDARY_SHELL 2.0f

void main()
{
	if (type0[0] == PARTICLE_TYPE_LAUNCHER) {
		EndPrimitive();
	} 
	else {
		vec4 center = viewProjMatrix * gl_in[0].gl_Position;

		vec2 dir = vec2(particleSize * 0.5, particleSize * 0.5);

		gl_Position = vec4(center.x + dir.x, center.y + dir.y, center.z, center.w);
		texCoords = vec2(1.0, 0.0);
		EmitVertex();

		gl_Position = vec4(center.x - dir.x, center.y + dir.y, center.z, center.w);
		texCoords = vec2(0.0, 0.0);
		EmitVertex();
	
		gl_Position = vec4(center.x + dir.x, center.y - dir.y, center.z, center.w);
		texCoords = vec2(1.0, 1.0);
		EmitVertex();
	
		gl_Position = vec4(center.x - dir.x, center.y - dir.y, center.z, center.w);
		texCoords = vec2(0.0, 1.0);
		EmitVertex();
	
		EndPrimitive();
	}
}